/* tree.h - declare structures used by tree library
 *
 * vix 22jan93 [revisited; uses RCS, ANSI, POSIX; has bug fixes]
 * vix 27jun86 [broken out of tree.c]
 *
 * $Id: tree.h,v 1.2 1998-05-13 00:47:28 pst Exp $
 */


#ifndef	__ISC_TREE_H__
#define	__ISC_TREE_H__

/*
 * tree_t is our package-specific anonymous pointer.
 */
#if defined(__STDC__) || defined(__GNUC__)
typedef	void *tree_t;
#else
typedef	char *tree_t;
#endif

typedef	struct tree_s {
	tree_t		data;
	struct tree_s	*left, *right;
	short		bal;
} tree;

__BEGIN_DECLS
extern void	tree_init	__P((tree **));
extern tree_t	tree_srch	__P((tree **, int (*)(), tree_t));
extern tree_t	tree_add	__P((tree **, int (*)(), tree_t, void (*)()));
extern int	tree_delete	__P((tree **, int (*)(), tree_t, void (*)()));
extern int	tree_trav	__P((tree **, int (*)()));
extern void	tree_mung	__P((tree **, void (*)()));
__END_DECLS

#endif	/* __ISC_TREE_H__ */
